/**
* @file serial.c
*
* Copyright (c) 2004 Atmel.
*
* @brief ̕UARTʐMp̊֐񋟂܂B
*
* @version 1.0 (CVS revision : 1.1)
* @date 2006/03/09 16:33:39
* @author raubree
*****************************************************************************/
#include "config.h"
#include "serial.h"

/**
* @brief	UART
* @param	Ȃ
* @pre		Ȃ
* @post		ꂽUART
*/
void init_uart(void)
{
  BAUD_RATE_LOW_REG = BRREG_VALUE;
  UART_CONTROL_REG = (1 << ENABLE_RECEIVER_BIT) |
					 (1 << ENABLE_TRANSMITTER_BIT);		// M
}

/**
* @brief	UARTŕM
* @param	char c
* @pre		UART
* @post		UART֑
*/
void sendchar(char c)
{
  UART_DATA_REG = c;											// M
  while (!(UART_STATUS_REG & (1 << TRANSMIT_COMPLETE_BIT)));	// O޲đMҋ@
  UART_STATUS_REG |= (1 << TRANSMIT_COMPLETE_BIT);				// M(TXC)׸މ
}

/**
* @brief	UART當M
* @param	Ȃ
* @pre		UART
* @post		UART_DATA_REGڼ޽ɕ
*/
char recchar(void)
{
  while(!(UART_STATUS_REG & (1 << RECEIVE_COMPLETE_BIT)));		// ްMҋ@
  return UART_DATA_REG;
}

/**
* @brief	ҌtUARTŕM
* @param	ch
* @pre		UART
* @post		mFƋUARTő
*/
int putchar(int ch)
{
  UART_DATA_REG = ch;											// M
  while (!(UART_STATUS_REG & (1 << TRANSMIT_COMPLETE_BIT)));	// O޲đMҋ@
  UART_STATUS_REG |= (1 << TRANSMIT_COMPLETE_BIT);				// M(TXC)׸މ
  return ch;
}

/**
* @brief	MĂ邩
* @param	Ȃ
* @pre		UART
* @post		FALSE:MȂATRUE:ML
*/
char tstrx(void)
{
  if (UART_STATUS_REG & (1 << RECEIVE_COMPLETE_BIT))
  {
	return TRUE;
  }
  else
  {
	return FALSE;
  }
}

/**
* @brief	UARTŕ񑗐M
* @param	string str
* @pre		UART
* @post		UARTő
*/
void putstring(char *str)
{
  char ch;

  while((ch=*str)!= '\0')
  {
	sendchar(ch);
	str++;
  }
}

/**
* @brief	UARTŐM
* @param	integer number
* @pre		UART
* @post		UARTő
*/
void putint(int number)
{
  char value[6]={0,0,0,0,0,0};

  while((number - 10000)>=0)
  {
	number -= 10000;
	value[5]++;
  }
  value[5] += '0';

  while((number - 1000)>=0)
  {
	number -= 1000;
	value[4]++;
  }
  value[4] += '0';

  while((number - 100)>=0)
  {
	number -= 100;
	value[3]++;
  }
  value[3] += '0';

  while((number - 10)>=0)
  {
	number -= 10;
	value[2]++;
  }
  value[2] += '0';

  value[1] = number + '0';
  value[0] = '\0';

  sendchar(value[5]);
  sendchar(value[4]);
  sendchar(value[3]);
  sendchar(value[2]);
  sendchar(value[1]);
}

/**
* @brief	UARTŕȂcharM
* @param	Ȃchar (U8) number
* @pre		UART
* @post		UART֑Ȃchar
*/
void putU8(U8 number)
{
  char value[3]={0,0,0};

  while((number - 100)>=0)
  {
	number -= 100;
	value[2]++;
  }
  value[2] += '0';

  while((number - 10)>=0)
  {
	number -= 10;
	value[1]++;
  }
  value[1] += '0';

  value[0] = number + '0';

  sendchar(value[2]);
  sendchar(value[1]);
  sendchar(value[0]);
}

/**
* @brief	UARTɕtM
* @param	t number
* @pre		UART
* @post		UART֑t
*/
void putS16(S16 number)
{
  char value[6]={0,0,0,0};

  if(number >= 0)
  {
	value[5]='+';
  }
  else
  {
	value[5]='-';
	number *= -1;
  }

  while((number - 10000)>=0)
  {
	number -= 10000;
	value[4]++;
  }
  value[4] += '0';

  while((number - 1000)>=0)
  {
	number -= 1000;
	value[3]++;
  }
  value[3] += '0';

  while((number - 100)>=0)
  {
	number -= 100;
	value[2]++;
  }
  value[2] += '0';

  while((number - 10)>=0)
  {
	number -= 10;
	value[1]++;
  }
  value[1] += '0';

  value[0] = number + '0';

  sendchar(value[5]);
  sendchar(value[4]);
  sendchar(value[3]);
  sendchar(value[2]);
  sendchar(value[1]);
  sendchar(value[0]);
}
